
'''
Driver definition for ixgbe driver.
'''

defineVmkDriver(
   name='ixgbe',
   version='3.4.17',
   description='Intel(R) 10 Gigabit PCI Express Network Driver',
   driverType='net',
   files=[('drivers/net/ixgbe',
           Split('''
			ixgbe_82598.c
			ixgbe_82599.c
			ixgbe_x540.c
			ixgbe_api.c
			ixgbe_common.c
			ixgbe_ethtool.c
			ixgbe_main.c
			ixgbe_vmdq.c
			ixgbe_param.c
			ixgbe_phy.c
			kcompat.c
			kcompat_ethtool.c
                 '''))],
   appends=dict(CPPDEFINES={
		'NET_DRIVER':None,
		'CONFIG_PROC_FS':None,
		'DISABLE_PACKET_SPLIT':None,
		'CONFIG_PCI_MSI':None,
		'__VMKERNEL_MODULE__':None,
		'__VMKNETDDI_QUEUEOPS__':None,
		'DRIVER_IXGBE':None,
		'CONFIG_INET_LRO':None,
		'CONFIG_NETDEVICES_MULTIQUEUE':None,
		'__USE_COMPAT_LAYER_2_6_18_PLUS__':None,
		'ESX_REV':'4.0',
		'ESX_DDK_BUILD_REV':'249663',
		'IXGBE_VMDQ':None,
		'IXGBE_NO_LRO':None,
		'IXGBE_NO_TX_NAPI':None,
                },
                CCFLAGS=['-w -Wno-error'],
               ),
   heapinfo=('1024*100', '1024*4096'),
)

