/*********************************************************************/
/*                     Intel Confidential                            */
/*********************************************************************/

/**********************************************************************
**                                                                   **
**                I N T E L   P R O P R I E T A R Y                  **
**                                                                   **
**   COPYRIGHT (c)  2001 - 2011  BY  INTEL  CORPORATION.       ALL   **
**   RIGHTS RESERVED.   NO PART OF THIS PROGRAM OR PUBLICATION MAY   **
**   BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A   **
**   RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER   **
**   LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,   **
**   MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT   **
**   THE PRIOR WRITTEN PERMISSION OF :                               **
**                                                                   **
**                      INTEL  CORPORATION                           **
**                                                                   **
**                2200 MISSION COLLEGE BOULEVARD                     **
**                                                                   **
**             SANTA  CLARA,  CALIFORNIA  95052-8119                 **
**                                                                   **
**********************************************************************/

/**********************************************************************
*                                                                     *
* INTEL CORPORATION PROPRIETARY INFORMATION                           *
* This software is supplied under the terms of a license agreement    *
* with Intel Corporation and may not be copied nor disclosed          *
* except in accordance with the terms of that agreement.              *
*                                                                     *
* Module Name:                                                        *
*   linuxdriveros_i.h                                                 *
*                                                                     *
* Abstract:                                                           *
*   This is the driver OSI portion of NAL Linux.                      *
*                                                                     *
***********************************************************************
* VSS Revision Control Information:
* ---------------------------------
*   $Workfile: linuxdriver.c $
*   $Date: 2011/06/20 13:26:27 $
*   $Archive: /QV2.0/nal/src/linux/driver/linuxnaldriver.c $
*   $Revision: 1.3 $
**********************************************************************/

#ifndef _LINUXDRIVEROS_I_H_
#define _LINUXDRIVEROS_I_H_


/* kmalloc flags */
#define NAL_LINUX_KERNEL_GFP_KERNEL         0x00000001
#define NAL_LINUX_KERNEL_GFP_DMA            0x00000002

#define NAL_LINUX_DRIVER_SET_KMALLOC_FLAGS(InFlags, OutFlags) \
    (InFlags & NAL_LINUX_KERNEL_GFP_KERNEL) ? OutFlags |= GFP_KERNEL : OutFlags; \
    (InFlags & NAL_LINUX_KERNEL_GFP_DMA)    ? OutFlags |= GFP_DMA    : OutFlags

unsigned char
nal_read_port8(
    unsigned short Port
    );

unsigned short
nal_read_port16(
    unsigned short Port
    );

unsigned int
nal_read_port32(
    unsigned short Port
    );

unsigned char
nal_write_port8(
    unsigned short   Port,
    unsigned char    Value
    );

unsigned char
nal_write_port16(
    unsigned short   Port,
    unsigned short   Value
    );

unsigned char
nal_write_port32(
    unsigned short   Port,
    unsigned int     Value
    );

unsigned char
nal_read_register8(
    void*   Address
    );

unsigned short
nal_read_register16(
    void*    Address
    );

unsigned int
nal_read_register32(
    void*        Address
    );

unsigned char
nal_write_register8(
    void*                   Address,
    unsigned char           Value
    );

unsigned char
nal_write_register16(
    void*                Address,
    unsigned short       Value
    );

unsigned char
nal_write_register32(
    void*                   Address,
    unsigned int            Value
    );

unsigned int
nal_mmap_address(
    void**                VirtualAddress,
    unsigned long long    PhysicalAddress,
    unsigned int*         Length
    );

unsigned int
nal_unmap_address(
    void*                 VirtualAddress,
    unsigned long long    PhysicalAddress,
    unsigned int          Length
    );

void
nal_delay_milliseconds(
    unsigned int Milliseconds
    );

void
nal_delay_microseconds(
    unsigned int Microseconds
    );

unsigned long long
nal_get_time_stamp(void);

unsigned long long
nal_get_time_stamps_per_microsecond(void);

void*
nal_allocate_memory(
    unsigned int      ByteCount,
    int               Flags
    );

void
nal_free_memory(
    void*         Address
    );

void
nal_free_memory_non_paged_pci(
    void*                  PDev,
    void*                  Address,
    unsigned long long     PhysicalAddress,
    unsigned int           Size
    );

unsigned long long
nal_get_physical_memory_address(
    void* VirtualAddress
    );

void*
nal_kmem_set(
    void*          Dest,
    int            Value,
    unsigned long  Size
    );

void*
nal_ktou_memcpy(
    void*          Dest,
    void*          Source,
    unsigned long  Size
    );

void*
nal_ktok_memcpy(
    void*          Dest,
    void*          Source,
    unsigned long  Size
    );

void*
nal_utok_memcpy(
    void*          Dest,
    void*          Source,
    unsigned long  Size
    );

int
nal_debug_print(
    char* Format,
    ...
    );

void
nal_enable_debug_print(
    unsigned char Enable
    );

#endif /* _LINUXDRIVEROS_I_H_ */
