###########################################################################
# Driver files

# core driver files
LIB_CFILES = nalioctldrv.c linuxnaldriver.c linuxnaldriveros_i.c linuxnaldriverpci_i.c linuxnaldriverdevice_i.c
# kernel dependend files
KERNEL_CFILES = linuxdriverpci_i.c linuxdriveros_i.c linuxdriver.c
KERNEL_HFILES = linuxdriverpci_i.h linuxdriveros_i.h linuxdriver.h linuxdriverversion.h
# all C files
CFILES = $(LIB_CFILES) $(KERNEL_CFILES)

# standard flags for module builds
EXTRA_CFLAGS += -DLINUX -D__KERNEL__ -DMODULE -O2 -pipe -Wall
EXTRA_CFLAGS += $(CFLAGS_EXTRA)

# platform dependend flags
ARCH := $(shell uname -m | sed 's/i.86/i386/')
IQVLIB = iqvlinux.a
ifeq ($(ARCH),ia64)
  IQVLIB = iqvlinux64.a
endif
ifeq ($(ARCH),x86_64)
  IQVLIB = iqvlinux64e.a
endif
ifeq ($(ARCH),i386)
  IQVLIB = iqvlinux32.a
endif
ifeq ($(ARCH),i586)
  IQVLIB = iqvlinux32.a
endif
ifeq ($(ARCH),i686)
  IQVLIB = iqvlinux32.a
endif
IQV_OBJS = $(LIB_CFILES:.c=.o)

# we need to know what platform the driver is being built on
# some additional features are only built on Intel platforms
ifeq ($(ARCH),alpha)
  EXTRA_CFLAGS += -ffixed-8 -mno-fp-regs
endif
ifeq ($(ARCH),x86_64)
  EXTRA_CFLAGS += -mcmodel=kernel -mno-red-zone
endif
ifeq ($(ARCH),ppc)
  EXTRA_CFLAGS += -m32 -mpowerpc -mmultiple -mno-bit-align -msoft-float
endif
ifeq ($(ARCH),ppc64)
  EXTRA_CFLAGS += -m64 -mmultiple -mno-bit-align
  LDFLAGS += -m64  -melf64ppc
endif

# pick a compiler
ifneq (,$(findstring egcs-2.91.66, $(shell cat /proc/version)))
  CC := kgcc gcc cc
else
  CC := gcc cc
endif
test_cc = $(shell $(cc) --version > /dev/null 2>&1 && echo $(cc))
CC := $(foreach cc, $(CC), $(test_cc))
CC := $(firstword $(CC))
ifeq (,$(CC))
  $(error Compiler not found)
endif
